function doDraw()
	love.graphics.setBackgroundColor(0, 0, 0)
	if not newGame then
		
		if not map then
			post_effect3:draw(function()
				for i,v in ipairs(background) do
					if v.layer > 1 then
						love.graphics.setColor(v.color[1], v.color[2], v.color[3], 180 )
						love.graphics.point(v.x, v.y)
						
						if love.math.random(10) == 1 and v.layer == 4 then
							love.graphics.setColor(love.math.random(150, 255),love.math.random(150, 255),love.math.random(150, 255))
							love.graphics.point(v.x + love.math.random(-1,1), v.y + love.math.random(-1,1))
						end
					end
				end
			end)
		else
			love.graphics.setBackgroundColor( 0, 0, 0 )
		end

		love.graphics.push()
		if zoom > 1 then love.graphics.translate((love.window.getWidth()/2)-(player.x/zoom), (love.window.getHeight()/2)-(player.y/zoom)) end

		for i,v in ipairs(planets) do
			if zoom == 1 and v.x < (love.window.getWidth() + v.size) * zoom and v.x > -v.size * zoom and v.y < (love.window.getHeight() + v.size) * zoom and v.y > -v.size* zoom  then
				v.visited = true
				love.graphics.setColor( 0, 0, 0 )
				love.graphics.circle("fill", v.x, v.y, v.size)
				love.graphics.setColor( v.r, v.g, v.b )
				if v.type == 1 then
					post_effect:draw(function()
						love.graphics.draw(planetsImg[1][planetsRotFrame], v.x - v.size, v.y - v.size, 0, v.size/252.5, v.size/252.5, 0, 0)
					end)
				elseif v.type == 2 then
					post_effect:draw(function()
						love.graphics.draw(planetsImg[2][planetsRotFrame2], v.x - v.size, v.y - v.size, 0, v.size/252.5, v.size/252.5, 0, 0)
					end)
				end
				if func.checkDistColl(v, player) then
					love.graphics.setColor( 0, 255, 0 )
				elseif v.faction > 0 then
					love.graphics.setColor( factions[v.faction]["color"] )
				else
					love.graphics.setColor( 255, 255, 0 )
				end
				if v.faction > 0 then
					love.graphics.print(v.name .. " - " .. factions[v.faction]["name"], (v.x/zoom) - (font1:getWidth( v.name .. " - " .. factions[v.faction]["name"] )/2), (v.y/zoom) - ((v.size/zoom) + 20))
				else
					love.graphics.print(v.name, (v.x/zoom) - (font1:getWidth( v.name )/2), (v.y/zoom) - ((v.size/zoom) + 20))
				end--
			elseif zoom > 1 and v.visited and v.x < (love.window.getWidth() + v.size) * zoom and v.x > (-love.window.getWidth()-v.size) * zoom and v.y < (love.window.getHeight() + v.size) * zoom and v.y > (-love.window.getHeight()-v.size)* zoom then
				
				love.graphics.setColor( v.r, v.g, v.b )
				love.graphics.circle("fill",v.x/zoom, v.y/zoom,4)
				if func.checkDistColl(v, player) then
					love.graphics.setColor( 0, 255, 0 )
				elseif v.faction > 0 then
					love.graphics.setColor( factions[v.faction]["color"] )
				else
					love.graphics.setColor( 255, 255, 0 )
				end
				if v.faction > 0 then
					love.graphics.print(v.name .. " - " .. factions[v.faction]["name"], (v.x/zoom) - (font1:getWidth( v.name .. " - " .. factions[v.faction]["name"] )/2), (v.y/zoom) - ((v.size/zoom) + 20))
				else
					love.graphics.print(v.name, (v.x/zoom) - (font1:getWidth( v.name )/2), (v.y/zoom) - ((v.size/zoom) + 20))
				end
				
				if TB.rectColl((love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)), (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)), 1, 1, v.x/zoom-8, v.y/zoom-8, 16, 16) then
					pid = i
					showPrice = true
				end
			end
		end
		
		if not map then
			post_effect3:draw(function()
				for i,v in ipairs(background) do
					if v.layer == 1 then
						love.graphics.setColor(v.color[1], v.color[2], v.color[3], 180 )
						love.graphics.point(v.x, v.y)
						
						if love.math.random(10) == 1 and v.layer == 4 then
							love.graphics.setColor(love.math.random(150, 255),love.math.random(150, 255),love.math.random(150, 255))
							love.graphics.point(v.x + love.math.random(-1,1), v.y + love.math.random(-1,1))
						end
					end
				end
			end)
		end
		
		for i,v in ipairs(bullets) do
			love.graphics.setColor(v.color)
			love.graphics.circle("fill", v.x, v.y, v.size, 4)
		end

		if waypoint and map then
			love.graphics.setColor(40,255,0)
			love.graphics.circle("line", waypointX/zoom, waypointY/zoom, 5, 4)
		elseif waypoint and not map then
			love.graphics.setColor(40,255,0)
			love.graphics.circle("line", waypointX2, waypointY2, 5, 4)
		end


		if zoom < 5 then
			for i,v in ipairs(objects) do
				if v.type == 1 then
					love.graphics.setColor(0, 0, 0)
					love.graphics.circle("fill", v.x, v.y, v.health)
					post_effect:draw(function()
						love.graphics.setColor(128, 128, 128)
						love.graphics.draw(planetsImg[1][planetsRotFrame], v.x - v.health, v.y - v.health, 0, v.health/252.5, v.health/252.5, 0, 0)
					end)
					love.graphics.setColor(0, 255, 0)
					love.graphics.print("Mass: " .. math.floor((v.health - 3)*10)+1 .. "/" .. (v.healthMax - 3)*10+1, v.x - (font1:getWidth( "Mass: " .. math.floor((v.health - 3)*10)+1 .. "/" .. (v.healthMax - 3)*10+1 )/2), v.y + v.health + 10)
				elseif v.type == 2 then
					love.graphics.setColor(v.color)
					love.graphics.draw(ships[v.shipType], v.x, v.y, v.angle, 1, 1, shipWidth / 2, shipHeight / 2)
					if v.faction > 0 then
						love.graphics.setColor(factions[v.faction]["color"])
						love.graphics.print(v.name .. " - " .. factions[v.faction]["name"], v.x - (font1:getWidth( v.name .. " - " .. factions[v.faction]["name"] )/2), v.y - 30)
					else
						love.graphics.setColor(0, 255, 0)
						love.graphics.print(v.name, v.x - (font1:getWidth(v.name )/2), v.y - 30)
					end
					love.graphics.setColor(0, 255, 0)
					love.graphics.print("Level: " .. v.level, v.x - (font1:getWidth( "Level: " .. v.level )/2), v.y + 20)
					love.graphics.print("HP: " .. math.floor((v.health - 3)*10)+1 .. "/" .. (v.healthMax - 3)*10+1, v.x - (font1:getWidth( "HP: " .. math.floor((v.health - 3)*10)+1 .. "/" .. (v.healthMax - 3)*10+1 )/2), v.y + 33)
				elseif v.type == 3 then
					love.graphics.setColor(255, 255, 255)
					love.graphics.draw(crateImg, v.x, v.y, 0, 1, 1, 4, 4)
				elseif v.type == 4 then
					love.graphics.setColor(255, 255, 255)
					love.graphics.draw(crateMinedImg, v.x, v.y, 0, 1, 1, 4, 4)
				elseif v.type == 5 then
					love.graphics.setColor(255, 255, 255)
					love.graphics.draw(crateImg, v.x, v.y, 0, 1, 1, 4, 4)
				elseif v.type == 6 then
					love.graphics.setColor(255, 255, 255)
					love.graphics.draw(crateImg, v.x, v.y, 0, 1, 1, 4, 4)
				end
			end
			
			if up or down or left or right then
				
				tempY = 0
				tempX = 0
				
				if up and not down then
					if left or right then
						tempY = 4
					else
						tempY = 5
					end
				elseif down and not up then
					if left or right then
						tempY = -4
					else
						tempY = -5
					end
				end
				
				if left and not right then
					if up or down then
						tempX = 4
					else
						tempX = 5
					end
				elseif right and not left then
					if up or down then
						tempX = -4
					else
						tempX = -5
					end
				end
				
				for i = 1,7 do
					love.graphics.setColor(60,255 - (i * 15),160,180 - (i * 10))
					if math.floor(shipTimer * 16) == i then
						if player.afterBurnerBoost > 0 then
							love.graphics.circle("line", player.x + ((tempX * (1.1 + math.floor(player.afterBurnerBoost/222))) * i), player.y + ((tempY * (1.1 + math.floor(player.afterBurnerBoost/222))) * i),8 - i,6)
						else
							love.graphics.circle("line", player.x + ((tempX * 1.1) * i), player.y + ((tempY * 1.1) * i),8 - i,6)
						end
					else
						
						if player.afterBurnerBoost > 0 then
							love.graphics.circle("line", player.x + (tempX * (i + math.floor(player.afterBurnerBoost/222))), player.y + (tempY * (i + math.floor(player.afterBurnerBoost/222))),8 - i,6)
						else
							love.graphics.circle("line", player.x + (tempX * i), player.y + (tempY * i),8 - i,6)
						end
					end
				end
			end
			
			
			love.graphics.setColor( 255, 255, 255 )
			post_effect:draw(function()
				love.graphics.draw(ship, player.x/zoom, player.y/zoom, rad, 1, 1, shipWidth / 2, shipHeight / 2)
				love.graphics.setColor(backgroundColor[1], backgroundColor[2], backgroundColor[3], 30)
				love.graphics.rectangle("fill",0,0,love.window.getWidth(), love.window.getHeight())
			end)
			love.graphics.setColor(0, 0, 0, 20)
			love.graphics.rectangle("fill",0,0,love.window.getWidth(), love.window.getHeight())
		else
			love.graphics.setColor( 0, 0, 255 )
			love.graphics.circle("fill", player.x/zoom, player.y/zoom, 3)
		end
		
		if showPrice then
			love.graphics.setColor( 0, 255, 0 )
			for j,k in ipairs(planets[pid]["inventory"]) do
				love.graphics.setColor( 50, 225, 50 )
				love.graphics.rectangle("line", (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)), (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 10 + (j * 23), 400, 20)
				love.graphics.setColor(0, 0, 0, 170 )
				love.graphics.rectangle("fill", (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom))+1, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 11 + (j * 23), 398, 18)
				love.graphics.setColor( 0, 255, 0 )
				tempAmount = 0
				for n,m in ipairs(inventory) do
					if k.name == m.name then
						tempAmount = m.amount
					end
				end
				love.graphics.print(k.name, (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)) + 3, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 13 + (j * 23))
				love.graphics.print("Price: " .. k.price, (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)) + 120, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 13 + (j * 23))
				love.graphics.print("Stock: "  .. k.amount, (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)) + 220, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 13 + (j * 23))
				love.graphics.print("Inventory: " .. tempAmount, (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)) + 310, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 13 + (j * 23))
			end
			
			for j,k in ipairs(planets[pid]["production"]) do
				love.graphics.setColor( 50, 225, 50 )
				love.graphics.rectangle("line", (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)), (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 20 + (#planets[pid]["inventory"] * 23) + (j * 23), 400, 20)
				love.graphics.setColor(0, 0, 0, 170 )
				love.graphics.rectangle("fill", (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom))+1, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 21 + (#planets[pid]["inventory"] * 23) + (j * 23), 398, 18)
				love.graphics.setColor( 0, 255, 0 )
				love.graphics.print(k.productionName, (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)) + 3, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 23 + (#planets[pid]["inventory"] * 23) + (j * 23))
				love.graphics.print("Level: " .. k.level, (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)) + 120, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 23 + (#planets[pid]["inventory"] * 23) + (j * 23))
				love.graphics.print("Price: " .. k.price, (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)) + 220, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 23 + (#planets[pid]["inventory"] * 23) + (j * 23))
				if k.level > 0 then
					love.graphics.print("Produced: " .. k.amount, (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)) + 310, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 23 + (#planets[pid]["inventory"] * 23) + (j * 23))
				end
			end
			
			for j,k in ipairs(planets[pid]["upgrades"]) do
				love.graphics.setColor( 50, 225, 50 )
				love.graphics.rectangle("line", (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)), (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 30 + (#planets[pid]["inventory"] * 23) + (#planets[pid]["production"] * 23) + (j * 23), 400, 20)
				love.graphics.setColor(0, 0, 0, 170 )
				love.graphics.rectangle("fill", (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom))+1, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 31 + (#planets[pid]["inventory"] * 23) + (#planets[pid]["production"] * 23) + (j * 23), 398, 18)
				love.graphics.setColor( 0, 255, 0 )
				tempAmount = 0
				for n,m in ipairs(inventory) do
					if k.name == m.name then
						tempAmount = m.amount
					end
				end
				love.graphics.print(k.name, (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)) + 3, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 33 + (#planets[pid]["inventory"] * 23) + (#planets[pid]["production"] * 23) + (j * 23))
				love.graphics.print("Price: " .. k.price, (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)) + 120, (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) + 33 + (#planets[pid]["inventory"] * 23) + (#planets[pid]["production"] * 23) + (j * 23))
			end
			showPrice = false
		end
		
		love.graphics.pop()

		if openWindow then
			love.graphics.setColor( 120, 255, 0 )
			love.graphics.rectangle("line",(love.window.getWidth()/2) - 381,(love.window.getHeight()/2) - 271,762,542)
			love.graphics.setColor( 0, 0, 0 , 170 )
			love.graphics.rectangle("fill",(love.window.getWidth()/2) - 380,(love.window.getHeight()/2) - 270,760,540)
			
			if trade then
				love.graphics.setColor( 0, 255, 0 )
				
				love.graphics.print("Trade", (love.window.getWidth()/2) - 370, (love.window.getHeight()/2) - 260)
				
				for i,v in ipairs(planets[pid]["inventory"]) do
					love.graphics.setColor( 50, 225, 50 )
					love.graphics.rectangle("line", (love.window.getWidth()/2) - 375, (love.window.getHeight()/2) - 255 + (i * 23), 750, 20)
					love.graphics.setColor( 0, 255, 0 )
					tempAmount = 0
					for j,k in ipairs(inventory) do
						if v.name == k.name then
							tempAmount = k.amount
						end
					end
					love.graphics.print(v.name, (love.window.getWidth()/2) - 370, (love.window.getHeight()/2) - 252 + (i * 23))
					love.graphics.print("Price: " .. v.price, (love.window.getWidth()/2) - 260, (love.window.getHeight()/2) - 252 + (i * 23))
					love.graphics.print("Stock: "  .. v.amount, (love.window.getWidth()/2) - 160, (love.window.getHeight()/2) - 252 + (i * 23))
					love.graphics.print("Inventory: " .. tempAmount, (love.window.getWidth()/2) - 50, (love.window.getHeight()/2) - 252 + (i * 23))
				end
			elseif produce then
				love.graphics.setColor( 0, 255, 0 )
				
				love.graphics.print("Production", (love.window.getWidth()/2) - 370, (love.window.getHeight()/2) - 260)
				
				for i,v in ipairs(planets[pid]["production"]) do
					love.graphics.setColor( 50, 225, 50 )
					love.graphics.rectangle("line", (love.window.getWidth()/2) - 375, (love.window.getHeight()/2) - 255 + (i * 23), 750, 20)
					love.graphics.setColor( 0, 255, 0 )
					love.graphics.print(v.productionName, (love.window.getWidth()/2) - 370, (love.window.getHeight()/2) - 252 + (i * 23))
					love.graphics.print("Level: " .. v.level, (love.window.getWidth()/2) - 260, (love.window.getHeight()/2) - 252 + (i * 23))
					love.graphics.print("Price: " .. v.price, (love.window.getWidth()/2) - 160, (love.window.getHeight()/2) - 252 + (i * 23))
					if v.level > 0 then
						love.graphics.print("Produced: " .. v.amount, (love.window.getWidth()/2) - 50, (love.window.getHeight()/2) - 252 + (i * 23))
						love.graphics.print("Prod. Pr.: "  .. v.production, (love.window.getWidth()/2) + 60, (love.window.getHeight()/2) - 252 + (i * 23))
					end
				end
			elseif upgrade then
				love.graphics.setColor( 0, 255, 0 )
				
				love.graphics.print("Upgrades", (love.window.getWidth()/2) - 370, (love.window.getHeight()/2) - 260)
				
				for i,v in ipairs(planets[pid]["upgrades"]) do
					love.graphics.setColor( 50, 225, 50 )
					love.graphics.rectangle("line", (love.window.getWidth()/2) - 375, (love.window.getHeight()/2) - 255 + (i * 23), 750, 20)
					love.graphics.setColor( 0, 255, 0 )
					love.graphics.print(v.name, (love.window.getWidth()/2) - 370, (love.window.getHeight()/2) - 252 + (i * 23))
					if v.name == "Repair" then
						love.graphics.print("Price: " .. v.price * (player.healthMax - player.health), (love.window.getWidth()/2) - 260, (love.window.getHeight()/2) - 252 + (i * 23))
					else
						love.graphics.print("Price: " .. v.price, (love.window.getWidth()/2) - 260, (love.window.getHeight()/2) - 252 + (i * 23))
					end
				end
			end
			love.graphics.setColor( 0, 255, 0 )
			love.graphics.print("Inventory: " .. player.inventory .. "/" .. player.inventoryMax, (love.window.getWidth()/2) - 50, (love.window.getHeight()/2) - 260)
			love.graphics.print("Money: " .. player.money, (love.window.getWidth()/2) - 260, (love.window.getHeight()/2) - 260)
		end

		if inven then
			love.graphics.setColor( 120, 255, 0 )
			love.graphics.rectangle("line",(love.window.getWidth()/2) - 201,(love.window.getHeight()/2) - 201, 402, 402)
			love.graphics.setColor( 0, 0, 0 , 170 )
			love.graphics.rectangle("fill",(love.window.getWidth()/2) - 200,(love.window.getHeight()/2) - 200, 400, 400)
			
			love.graphics.setColor( 0, 255, 0 )
			
			love.graphics.print("Inventory", (love.window.getWidth()/2) - (font1:getWidth("Inventory")/2), (love.window.getHeight()/2) - 195)
			
			for i,v in ipairs(inventory) do
				love.graphics.setColor( 50, 225, 50 )
				love.graphics.rectangle("line", (love.window.getWidth()/2) - 198, (love.window.getHeight()/2) - 200 + (i * 23), 396, 20)
				love.graphics.setColor( 0, 255, 0 )
				love.graphics.print(v.name .. ": - Amount: "  .. v.amount, (love.window.getWidth()/2) - 195, (love.window.getHeight()/2) - 197 + (i * 23))
			end
		end

		love.graphics.setFont(font1)
		love.graphics.setColor( 0, 255, 0 )

		if map then
			love.graphics.rectangle("line", 1, 1, love.window.getWidth()-1, love.window.getHeight()-1 )
			love.graphics.print( "Map - Zoom: " .. zoom - 30 .. " - 'Page Up' or 'Mouse Wheel Up' to zoom out. 'Page Down' or 'Mouse Wheel Down' to zoom in. 'TAB' to set way point.", 10, 10)
			if waypoint then
				love.graphics.print("WX:" .. math.floor(player.x - waypointX) .. " WY:" .. math.floor(player.y - waypointY), 10, 25)
			end
		elseif not map and not newGame and not openWindow then
			love.graphics.print( "HP: " .. player.health .. "/" .. player.healthMax .. " - XP: " .. player.xp .. "/" .. player.xpNext .. " - MONEY: " .. player.money .. " - INVENTORY: " .. player.inventory .. "/" .. player.inventoryMax .. " - FPS: " .. love.timer.getFPS() .. " - X: " .. math.floor(X) .. " - Y: " .. math.floor(Y) .. timestr,15,15)
			love.graphics.print( "LEVEL: " .. player.level .. " - ATTACK: " .. player.attack .. " - DEFENCE: " .. player.defence .. " - SPEED: " .. math.floor((player.speed/10) - 14) .. " - AFTERBURNER: " .. math.floor(player.afterBurner) .. "/" .. player.afterBurnerMax .. " - BULLET SPEED: " .. (player.bulletSpeed/10) - 29, 15, 30)
			if waypoint then
				love.graphics.print("WPX:" .. math.floor(player.x - waypointX) .. " WPY:" .. math.floor(player.y - waypointY), 15, 45)
			end
		elseif upgrade then
			love.graphics.print( "HP: " .. player.health .. "/" .. player.healthMax .. " - ATTACK: " .. player.attack .. " - DEFENCE: " .. player.defence .. " - SPEED: " .. math.floor((player.speed/10) - 14) .. " - AFTERBURNER: " .. math.floor(player.afterBurner) .. "/" .. player.afterBurnerMax .. " - BULLET SPEED: " .. (player.bulletSpeed/10) - 29 .. " - INVENTORY: " .. player.inventory .. "/" .. player.inventoryMax, 25, 10)
		end

		if gameOver then
			love.graphics.print( "Game Over", (love.window.getWidth()/2) - (font1:getWidth("Game Over")/2), 395)
		end

		if X >= universSize or Y >= universSize or X <= -universSize or Y <= -universSize then
			love.graphics.print( "Out of bounds!", (love.window.getWidth()/2) - (font1:getWidth("Out of bounds!")/2), 375)
		end
	else
		love.graphics.setColor(0, 0, 0)
		love.graphics.rectangle("fill",0,0,love.window.getWidth(), love.window.getHeight())
	end
	
	if paused then
		love.graphics.setColor( 120, 255, 0 )
		love.graphics.rectangle("line",(love.window.getWidth()/2) - 201, (love.window.getHeight()/2) - 201,402,402)
		love.graphics.setColor( 0, 0, 0, 170 )
		love.graphics.rectangle("fill",(love.window.getWidth()/2) - 200,(love.window.getHeight()/2) - 200,400,400)
			
		love.graphics.setColor( 0, 255, 0 )
			
		love.graphics.print("Menu", (love.window.getWidth()/2) - (font1:getWidth("Menu:")/2), (love.window.getHeight()/2) - 190)
	end
	TB.draw()
	love.graphics.setColor(0, 255, 0)
	--love.graphics.line(love.window.getWidth()/2, 0, love.window.getWidth()/2, love.window.getHeight())
	
	for i,v in ipairs(msgs) do
		if v.timer < 2 then
			love.graphics.setColor(0, 0, 0)
			love.graphics.print(v.msg, v.x + 1, v.y + 1 - (v.timer * 50))
			love.graphics.setColor(0, 255, 0)
			love.graphics.print(v.msg, v.x, v.y - (v.timer * 50))
		else
			love.graphics.setColor(0, 0, 0)
			love.graphics.print(v.msg, v.x + 1, v.y + 1 - (v.timer * 50))
			love.graphics.setColor(0, 255, 0, 255 - ((v.timer - 2) * 255))
			love.graphics.print(v.msg, v.x, v.y - (v.timer * 50))
		end
	end
	if loading > 0 then
		love.graphics.setColor(0, 0, 0)
		love.graphics.rectangle("fill", 0, 0, love.window.getWidth(), love.window.getHeight())
		love.graphics.setColor(0, 255, 0)
		love.graphics.print("Loading...", (love.window.getWidth()/2) - (font1:getWidth("Loading...")/2), love.window.getHeight()/2)
	end
end