local func = {}

function func.createBG()
	background = {}
	for i = 1,love.window.getHeight()/3 do
		local tempLayer = love.math.random(4)
		if tempLayer == 1 then
			table.insert(background, {x = love.math.random(love.window.getWidth()+100), y = love.math.random(love.window.getHeight()+100), layer = tempLayer, extra = false, color = {love.math.random(10,255), love.math.random(10,255), love.math.random(10,255)}})
		else
			table.insert(background, {x = love.math.random(love.window.getWidth()+100), y = love.math.random(love.window.getHeight()+100), layer = tempLayer, extra = false, color = {love.math.random(150,255), love.math.random(150,255), love.math.random(150,255)}})
		end
	end
end

function func.createSND()
	src1 = love.audio.newSource("data/sounds/laser.wav")
	src1:setVolume(0.4)
	src1:setPitch(2.6)
end

function func.createInventory()
	for i,v in ipairs(inventory) do
		TB.create(
		(love.window.getWidth()/2) + 108, 
		(love.window.getHeight()/2) - 199 + (i * 23), 
		50, 
		tbox.height, 
		tbox.border, 
		v.amount,
		tbox.font, 
		tbox.textOffsetX, 
		tbox.textOffsetY, 
		tbox.borderColor, 
		tbox.backgroundColor,
		tbox.backgroundSelectedColor,
		tbox.borderSelectedColor,
		tbox.textColor,
		tbox.textSelectedColor,
		v.name, 
		tbox.drawBoxes,
		false,
		tbox.centerText,
		tbox.drawBackground,
		tbox.selectable,
		{"Drop", func.buttonDrop}
	)
	end
end

function func.createMenu()

	TB.create(
		(love.window.getWidth()/2) - 93, 
		(love.window.getHeight()/2) - 112, 
		50, 
		tbox.height, 
		tbox.border, 
		settings.screenWidth, 
		tbox.font, 
		tbox.textOffsetX, 
		tbox.textOffsetY, 
		tbox.borderColor, 
		tbox.backgroundColor,
		tbox.backgroundSelectedColor,
		tbox.borderSelectedColor,
		tbox.textColor,
		tbox.textSelectedColor,
		"resX",
		tbox.drawBoxes,
		true,
		tbox.centerText,
		tbox.drawBackground,
		tbox.selectable
	)
	
	TB.create(
		(love.window.getWidth()/2) - 40, 
		(love.window.getHeight()/2) - 112, 
		50, 
		tbox.height, 
		tbox.border, 
		settings.screenHeight, 
		tbox.font, 
		tbox.textOffsetX, 
		tbox.textOffsetY, 
		tbox.borderColor, 
		tbox.backgroundColor,
		tbox.backgroundSelectedColor,
		tbox.borderSelectedColor,
		tbox.textColor,
		tbox.textSelectedColor,
		"resY",
		tbox.drawBoxes,
		true,
		tbox.centerText,
		tbox.drawBackground,
		tbox.selectable,
		{"Set Resolution", func.buttonSetR}
	)

	TB.create(
		(love.window.getWidth()/2) - 99, 
		(love.window.getHeight()/2) - 136, 
		tbox.width, 
		tbox.height, 
		tbox.border, 
		settings["filename"], 
		tbox.font, 
		tbox.textOffsetX, 
		tbox.textOffsetY, 
		tbox.borderColor, 
		tbox.backgroundColor,
		tbox.backgroundSelectedColor,
		tbox.borderSelectedColor,
		tbox.textColor,
		tbox.textSelectedColor,
		"save",
		tbox.drawBoxes,
		false,
		tbox.centerText,
		tbox.drawBackground,
		tbox.selectable,
		{"Save", func.buttonSave},
		{"Load", func.buttonLoad}
	)
	TB.create(
		(love.window.getWidth()/2) - 36,
		(love.window.getHeight()/2) - 160,
		0, 
		tbox.height, 
		tbox.border, 
		tbox.text, 
		tbox.font, 
		tbox.textOffsetX, 
		tbox.textOffsetY, 
		tbox.borderColor, 
		tbox.backgroundColor,
		tbox.backgroundSelectedColor,
		tbox.borderSelectedColor,
		tbox.textColor,
		tbox.textSelectedColor,
		tbox.name,
		tbox.drawBoxes,
		false,
		tbox.centerText,
		tbox.drawBackground,
		tbox.selectable,
		{"New Game", func.makeNewGame}
	)
	TB.create(
		(love.window.getWidth()/2) - 19,
		(love.window.getHeight()/2) + 150,
		0, 
		tbox.height, 
		tbox.border, 
		tbox.text, 
		tbox.font, 
		tbox.textOffsetX, 
		tbox.textOffsetY, 
		tbox.borderColor, 
		tbox.backgroundColor,
		tbox.backgroundSelectedColor,
		tbox.borderSelectedColor,
		tbox.textColor,
		tbox.textSelectedColor,
		tbox.name,
		tbox.drawBoxes,
		false,
		tbox.centerText,
		tbox.drawBackground,
		tbox.selectable,
		{"Exit", func.buttonExit}
	)
end

function func.findRotation(x1,y1,x2,y2)
	return math.atan2(y2 - y1, x2 - x1)
end

function func.colliding( x1, y1, w1, h1, x2, y2, w2, h2 )
	if x1 + w1 > x2 and x1 < x2 + w2 and y1 + h1 > y2 and y1 < y2 + h2 then		
		return true			
	else
		return false	
	end
end

function func.checkDistColl(circleA, circleB)
	local dist = (circleA.x - circleB.x)^2 + (circleA.y - circleB.y)^2
	return dist <= ((circleA.size) + (circleB.size))^2
end

function func.checkDistColl2(circleA, circleB)
	local dist = (circleA.x - circleB.x)^2 + (circleA.y - circleB.y)^2
	return dist <= ((circleA.size*10) + (circleB.size*10))^2
end

function func.buyproduction()
	if timer > 0.4 and tonumber(TB.getTextSelected()) then
		timer = 0
		for i,v in ipairs(planets[pid]["production"]) do
			if TB.getNameSelected() == v.name and tonumber(TB.getTextSelected()) * v.price <= player.money and v.level < 20 then
				for i = 1, tonumber(TB.getTextSelected()) do
					player.money = player.money - v.price
					v.price = math.floor(v.price * 1.15)
					v.level = v.level + 1
					v.production = math.ceil(v.production * 1.15)
				end
			end
		end
	end
end

function func.getproduction()
	if timer > 0.4 and tonumber(TB.getTextSelected()) then
		timer = 0
		for i,v in ipairs(planets[pid]["production"]) do
			if TB.getNameSelected() == v.name and v.amount > 0 then
				if player.inventoryMax - player.inventory >= tonumber(TB.getTextSelected()) then
					found = false
					for j,k in ipairs(inventory) do
						if k.name == v.name then
							found = true
							k.amount = k.amount + tonumber(TB.getTextSelected())
						end
					end
					if not found then
						table.insert(inventory, {name = v.name, amount = tonumber(TB.getTextSelected())})
					end
					player.inventory = player.inventory + tonumber(TB.getTextSelected())
					v.amount = v.amount - tonumber(TB.getTextSelected())
				end
			end
		end
	end
end

function func.getallproduction()
	if timer > 0.4 then
		timer = 0
		for i,v in ipairs(planets[pid]["production"]) do
			if TB.getNameSelected() == v.name and v.amount <= player.inventoryMax - player.inventory then
				found = false
				for j,k in ipairs(inventory) do
					if k.name == v.name then
						found = true
						k.amount = k.amount + v.amount
					end
				end
				if not found then
					table.insert(inventory, {name = v.name, amount = v.amount})
				end
				player.inventory = player.inventory + v.amount
				v.amount = 0
			end
		end
	end
end

function func.buyupgrade()
	if timer > 0.4 and tonumber(TB.getTextSelected()) then
		timer = 0
		for i,v in ipairs(planets[pid]["upgrades"]) do
			if TB.getNameSelected() == v.name and v.price <= player.money then
				if v.name == "Attack" then
					player.attack = player.attack + 1
					player.money = player.money - v.price
					for n,m in ipairs(planets) do
						for j,k in ipairs(planets[n]["upgrades"]) do
							if k.name == v.name then
								k.price = math.floor(k.price * 1.15)
							end
						end
					end
				elseif v.name == "Guns" and player.guns < 3 then
					player.guns = player.guns + 1
					player.money = player.money - v.price
					for n,m in ipairs(planets) do
						for j,k in ipairs(planets[n]["upgrades"]) do
							if k.name == v.name then
								k.price = math.floor(k.price * 2)
							end
						end
					end
				elseif v.name == "Defence" then
					player.defence = player.defence + 1
					player.money = player.money - v.price
					for n,m in ipairs(planets) do
						for j,k in ipairs(planets[n]["upgrades"]) do
							if k.name == v.name then
								k.price = math.floor(k.price * 1.15)
							end
						end
					end
				elseif v.name == "Speed" then
					player.speedMax = player.speedMax + 10
					player.speed = player.speedMax
					player.money = player.money - v.price
					for n,m in ipairs(planets) do
						for j,k in ipairs(planets[n]["upgrades"]) do
							if k.name == v.name then
								k.price = math.floor(k.price * 1.15)
							end
						end
					end
				elseif v.name == "Bullet Speed" and player.bulletSpeed < 950 then
					player.bulletSpeed = player.bulletSpeed + 10
					player.money = player.money - v.price
					for n,m in ipairs(planets) do
						for j,k in ipairs(planets[n]["upgrades"]) do
							if k.name == v.name then
								k.price = math.floor(k.price * 1.15)
							end
						end
					end
				elseif v.name == "HP" then
					player.healthMax = player.healthMax + 2
					player.health = player.healthMax
					player.money = player.money -  v.price
					for n,m in ipairs(planets) do
						for j,k in ipairs(planets[n]["upgrades"]) do
							if k.name == v.name then
								k.price = math.floor(k.price * 1.15)
							end
						end
					end
				elseif v.name == "Repair" and player.health < player.healthMax and player.money >= (player.healthMax - player.health) * v.price then
					player.money = player.money - ((player.healthMax - player.health) * v.price)
					player.health = player.healthMax
				elseif v.name == "Inventory" then
					player.inventoryMax = player.inventoryMax + 5
					player.money = player.money - v.price
					for n,m in ipairs(planets) do
						for j,k in ipairs(planets[n]["upgrades"]) do
							if k.name == v.name then
								k.price = math.floor(k.price * 1.15)
							end
						end
					end
				elseif v.name == "Afterburner" then
					player.afterBurnerMax = player.afterBurnerMax + 2
					player.afterBurner = player.afterBurnerMax
					player.afterBurnerTimerSet = player.afterBurnerTimerSet - 0.02
					player.money = player.money - v.price
					for n,m in ipairs(planets) do
						for j,k in ipairs(planets[n]["upgrades"]) do
							if k.name == v.name then
								k.price = math.floor(k.price * 1.15)
							end
						end
					end
				end	
			end
		end
	end
end

function func.buttonBuy()
	if timer > 0.4 and tonumber(TB.getTextSelected()) then
		timer = 0
		for i,v in ipairs(planets[pid]["inventory"]) do
			if TB.getNameSelected() == v.name and tonumber(TB.getTextSelected()) <= player.inventoryMax - player.inventory and player.money >= tonumber(TB.getTextSelected()) * v.price then
				v.amount = v.amount - tonumber(TB.getTextSelected())
				player.inventory = player.inventory + tonumber(TB.getTextSelected())
				player.money = player.money - tonumber(TB.getTextSelected()) * v.price
			
				found = false
				for j,k in ipairs(inventory) do
					if k.name == v.name then
						found = true
						k.amount = k.amount + tonumber(TB.getTextSelected())
					end
				end
				if not found then
					table.insert(inventory, {name = v.name, amount = tonumber(TB.getTextSelected())})
				end
			end
		end
	end
end

function func.buttonSell()
	if timer > 0.4 and tonumber(TB.getTextSelected()) then
		timer = 0
		for i,v in ipairs(inventory) do
			if TB.getNameSelected() == v.name and tonumber(TB.getTextSelected()) <= v.amount then
				for j,k in ipairs(planets[pid]["inventory"]) do
					if k.name == v.name then
						k.amount = k.amount + tonumber(TB.getTextSelected())
						player.inventory = player.inventory - tonumber(TB.getTextSelected())
						player.money = player.money + (tonumber(TB.getTextSelected()) * k.price)
						v.amount = v.amount - tonumber(TB.getTextSelected())
						if v.amount == 0 then
							table.remove(inventory, i)
						end
					end
				end
			end
		end
	end
end

function func.buttonSellAll()
	if timer > 0.4 then
		timer = 0
		for i,v in ipairs(inventory) do
			if TB.getNameSelected() == v.name then
				for j,k in ipairs(planets[pid]["inventory"]) do
					if k.name == v.name then
						k.amount = k.amount + v.amount
						player.inventory = player.inventory - v.amount
						player.money = player.money + (v.amount * k.price)
						table.remove(inventory, i)
					end
				end
			end
		end
	end
end

function func.buttonSave()
	if not newGame and timer > 0.4 then
		timer = 0
		settings.filename = TB.getTextSelected()
		table.insert(msgs, {msg = "Saved to " .. TB.getTextSelected() .. ".sav", x = love.mouse.getX() - (font1:getWidth( "Saved to " .. TB.getTextSelected() .. ".sav" )/2), y = love.mouse.getY() - 20, timer = 0})
		saves = {inventory, player, planets, factions, objects, bullets, {hour, min, sec}, {X, Y}}
		persistence.store(TB.getTextSelected() .. ".sav", saves)
		persistence.store("Settings.lua", settings)
		saves = {}
	end
end

function func.buttonLoad()
	if persistence.load(TB.getTextSelected() .. ".sav") then
		loading = 10
	end
end

function func.buttonDrop()
	if timer > 0.4 then
		timer = 0
		table.insert(objects, {x = player.x - 30, y = player.y, size = 8, type = 5, amount = tonumber(TB.getTextSelected()), name = TB.getNameSelected()})
		for i,v in ipairs(inventory) do
			if v.name == TB.getNameSelected() and v.amount >= tonumber(TB.getTextSelected()) then
				v.amount = v.amount - tonumber(TB.getTextSelected())
				player.inventory = player.inventory - tonumber(TB.getTextSelected())
				if v.amount == 0 then
					table.remove(inventory, i)
					TB.destroyAll()
					for i,v in ipairs(inventory) do
						TB.create(
							(love.window.getWidth()/2) + 108, 
							(love.window.getHeight()/2) - 199 + (i * 23), 
							50, 
							tbox.height, 
							tbox.border, 
							v.amount,
							tbox.font, 
							tbox.textOffsetX, 
							tbox.textOffsetY, 
							tbox.borderColor, 
							tbox.backgroundColor,
							tbox.backgroundSelectedColor,
							tbox.borderSelectedColor,
							tbox.textColor,
							tbox.textSelectedColor,
							v.name, 
							tbox.drawBoxes,
							false,
							tbox.centerText,
							tbox.drawBackground,
							tbox.selectable,
							{"Drop", func.buttonDrop}
						)
					end
				end
			end
		end
	end
end

function func.buttonExit()
	love.event.quit()
end

function func.buttonSetR()
	if timer > 0.4 and tonumber(TB.getText("resX")) and tonumber(TB.getText("resY")) and tonumber(TB.getText("resY")) >= 600 and tonumber(TB.getText("resX")) >= 800 and tonumber(TB.getText("resY")) <= 1080 and tonumber(TB.getText("resX")) <= 1920 then
		timer = 0
		table.insert(msgs, {msg = "Resolution changed, restart needed!", x = love.mouse.getX() - (font1:getWidth( "Resolution changed, restart needed!" )/2), y = love.mouse.getY() - 20, timer = 0})
		settings.screenWidth = tonumber(TB.getText("resX"))
		settings.screenHeight = tonumber(TB.getText("resY"))
		persistence.store("Settings.lua", settings)
		
		TB.destroyAll()
		func.createMenu()
		
		if paused then
			TB.destroyAll()
			func.createMenu()
		end
	end
end

function func.createAsteroid()
	if love.math.random(2) == 1 then
		tx = love.math.random(-4000,-100)
		ty = love.math.random(-4000,-100)
	else
		tx = love.math.random(love.window.getWidth() + 100,love.window.getWidth() + 4000)
		ty = love.math.random(love.window.getHeight() + 100,love.window.getHeight() + 4000)
	end
	local healthTemp = love.math.random(5,30) - 0.1
	table.insert(objects, {x = tx, y = ty, type = 1, health = healthTemp, healthMax = healthTemp, size = healthTemp})
end

function func.createShip()
	if love.math.random(2) == 1 then
		tx = love.math.random(-4000,-100)
		ty = love.math.random(-4000,-100)
	else
		tx = love.math.random(love.window.getWidth() + 100,love.window.getWidth() + 4000)
		ty = love.math.random(love.window.getHeight() + 100,love.window.getHeight() + 4000)
	end

	local Level = love.math.random(player.level - 5, player.level + 5)
	if love.math.random(30) == 1 then
		Level = Level + love.math.random(5)
	end
	if Level < 1 then
		Level = 1
	end

	local healthTemp = love.math.random(Level + 3, Level + 4) - 0.1

	local Planet = love.math.random(#planets)
	local startX = tx
	local startY = ty
	local stopX = planets[Planet]["x"]
	local stopY = planets[Planet]["y"]

	local rot = math.atan2((stopY - startY), (stopX - startX))

	local sDx = 100 * math.cos(rot)
	local sDy = 100 * math.sin(rot)

	local shipT = love.math.random(6)

	local fac = love.math.random(20)
	if fac > 10 then
		fac = 0
	end

	if fac > 0 then
		col = factions[fac]["color"]
	else
		col = {love.math.random(100,255), love.math.random(100,255), love.math.random(100,255)}
	end
	
	
	if Level <= 50 and math.random(100) - Level == 1 then
		Guns = love.math.random(3)
	elseif Level > 50 then
		Guns = 3
	else
		Guns = 1
	end
	
	scol = {love.math.random(100,255), love.math.random(100,255), love.math.random(100,255)}

	local Name = ""
	if love.math.random(4) == 1 then
		Name = namem.makeName()
	else
		Name = namem.makeName() .. " " .. namem.makeName()
	end


	local Status = 1
	if love.math.random(100) == 1 then
		Status = 2
	end
	table.insert(objects, {x = tx, y = ty, type = 2, name = Name, level = Level, health = healthTemp, healthMax = healthTemp, destX = planets[love.math.random(#planets)]["x"], destY = planets[love.math.random(#planets)]["y"], dx = sDx, dy = sDy, angel = rot, color = col, shipType = shipT, size = 14, faction = fac, status = Status, timer = 0, planet = Planet, shotColor = scol, guns = Guns})
end

function func.createImgs()
	planetsImg = {{},{}}
	for i = 0,99 do
		planetsImg[1][i] = love.graphics.newImage("data/planets/planet1/planet1-" .. i ..".png")
	end
	for i = 0,199 do
		planetsImg[2][i] = love.graphics.newImage("data/planets/planet2/planet2-" .. i ..".png")
	end
	
	crateImg = love.graphics.newImage("data/crate.png")
	crateMinedImg = love.graphics.newImage("data/crateMined.png")
	
	ship = love.graphics.newImage("data/ship.png")

	ships = {}
	for i = 1,6 do
		ships[i] = love.graphics.newImage("data/ships/ship" .. i .. ".png")
	end

	shipWidth = ship:getWidth()
	shipHeight = ship:getHeight()
end

function func.makeNewGame()
	loading = 1
end

function func.loadGame()
	func.createImgs()
	func.createBG()
	func.createSND()
	table.insert(msgs, {msg = "Loaded " .. TB.getTextSelected() .. ".sav", x = love.mouse.getX() - (font1:getWidth( "Loaded " .. TB.getTextSelected() .. ".sav" )/2), y = love.mouse.getY() - 20, timer = 0})
	settings.filename = TB.getTextSelected()
	persistence.store("Settings.lua", settings)
	loads = persistence.load(TB.getTextSelected() .. ".sav")
	inventory = loads[1]
	player = loads[2]
	if player.x*2 ~= love.window.getWidth() then
		player.x = love.window.getWidth()/2
		player.y = love.window.getHeight()/2
	end
	planets = loads[3]
	factions = loads[4]
	objects = loads[5]
	bullets = loads[6]
	hour = loads[7][1]
	min = loads[7][2]
	sec = loads[7][3]
	X = loads[8][1]
	Y = loads[8][2]
	backgroundColor = {20, 20, 50}
	gameOver = false
	newGame = false
	paused = false
	menu = false
	TB.destroyAll()
	loading = 0
end

function func.newGame()
	func.createImgs()
	func.createSND()
	gameOver = false
	newGame = false
	paused = false
	menu = false
	TB.destroyAll() 
	inven = false	
	bullets = {}
	background = {}
	inventory = {}
	planets = {}
	objects = {}
	factions = {}
	hour = 0
	min = 0
	sec = 0
	X = 0
	Y = 0
	backgroundColor = {20, 20, 50}
	player = playerSet
	
	func.createBG()
	
	for i = 1,10 do
		
		Name = namem.makeName(4,6)
	
		table.insert(factions, {
			name = Name,
			color = {love.math.random(100,255), love.math.random(100,255), love.math.random(100,255)},
			rep = 50,
			stat = love.math.random(3)
		})
	end
	
	for ic = 1,1000 do
		if math.random(4) == 1 then 
			Name = namem.makeName() .. " " .. namem.makeName()
		else
			Name = namem.makeName()
		end
	
		local tempInventory = {}
		for i,v in ipairs(resources) do
			if love.math.random(v.rarity) == 1 then
				table.insert(tempInventory, {name = v.name, amount = love.math.random(1000/v.rarity), price = math.floor(love.math.random(v.value/12,v.value/10) * 10), produces = true, rarity = v.rarity, productionName = v.productionName})
			else
				if math.random(7) == 1 then
					table.insert(tempInventory, {name = v.name, amount = 0, price = math.floor(love.math.random(v.value/12,v.value/10) * 10), produces = false, rarity = v.rarity, productionName = v.productionName})
				end
			end
		end
		
		local tempUpgrades = {}
		for i = 1,9 do
			if love.math.random(5) == 1 then
				if i == 1 then
					table.insert(tempUpgrades, {name = "Attack", price = love.math.random(75,100) * 100})
				elseif i == 2 then
					table.insert(tempUpgrades, {name = "Defence", price = love.math.random(75,100) * 100})
				elseif i == 3 then
					table.insert(tempUpgrades, {name = "Speed", price = love.math.random(75,100) * 100})
				elseif i == 4 then
					table.insert(tempUpgrades, {name = "Bullet Speed", price = love.math.random(75,100) * 100})
				elseif i == 5 then
					table.insert(tempUpgrades, {name = "HP", price = love.math.random(75,100) * 100})
				elseif i == 6 then
					table.insert(tempUpgrades, {name = "Afterburner", price = love.math.random(75,100) * 100})
				elseif i == 7 then
					table.insert(tempUpgrades, {name = "Inventory", price = love.math.random(75,100) * 100})
				elseif i == 8 then
					table.insert(tempUpgrades, {name = "Guns", price = love.math.random(75,100) * 1000})
				end
			end
			if i == 9 then
				table.insert(tempUpgrades, {name = "Repair", price = love.math.random(300,500)})
			end
		end
		
		local tempProduction = {}
		for i,v in ipairs(tempInventory) do
			if v.produces and v.productionName then
				table.insert(tempProduction, {name = v.name, productionName = v.productionName, price = love.math.random(v.rarity/1.3,v.rarity) * 10000, level = 0, amount = 0, production = math.floor(13 - (v.rarity/8))})
			end
		end
	
		local fac = love.math.random(15)
		if fac > 10 then
			fac = 0
		end
	
		table.insert(planets, {	
			inventory = tempInventory,
			upgrades = tempUpgrades,
			production = tempProduction,
			id = ic, 
			name = Name,
			faction = fac,
			x = love.math.random(-universSize,universSize), 
			y = love.math.random(-universSize,universSize), 
			size = love.math.random(100,400),
			visited = false, 
			r = love.math.random(40,255),
			g = love.math.random(40,255), 
			b = love.math.random(40,255),
			type = love.math.random(2)
		})
	end

	for i,v in ipairs(planets) do
		for k,l in ipairs(planets) do
			if func.checkDistColl2(v, l) and i ~= k then
				table.remove(planets, k)
			end
		end
	end

	for i = 1,5 do
		func.createAsteroid()
	end

	for i = 1,20 do
		func.createShip()
	end
	loading = 0
end

return func