--[[ 
Copyright (c) 2015 Ludvig Alexander Verpe 
]]--

TB = require "textbox"
tablepersistence = require "tablepersistence"
shine = require "shine"
namem = require "namem"
func = require "functions"
Draw = require "draw"
Update = require "update"

function love.load()
	gameVersion = 0.1
	
	love.math.setRandomSeed(love.math.random(os.time()))
	
	--love.graphics.setDefaultFilter( 'nearest', 'linear', 1 )
	font1 = love.graphics.newFont(10)
	crosshair = love.mouse.newCursor("data/cursor.png", 10, 10)
    love.mouse.setCursor(crosshair)
	
	if persistence.load("settings.lua") then
		settings = persistence.load("settings.lua")
	else
		settings = {filename = "Save1" , screenWidth = love.window.getWidth(), screenHeight = love.window.getHeight(), tempZoom = 31}
	end
	local vignette = shine.vignette{radius = 0.55, opacity = 0.1}
	
	local godsray = shine.godsray{exposure = 0.2, decay = 0.90, density = 0.1, weight = 0.25}
	
	local godsray2 = shine.godsray{exposure = 0.38, decay = 0.98, density = 0.01, weight = 0.3}
	
	local shines = shine.glowsimple{sigma = 0.9}
	
	local grain = shine.filmgrain{opacity = 1}

    local desaturate = shine.desaturate{strength = 0.15, tint = {160,180,30}}

    post_effect = vignette:chain(shines)--godsray:chain(shines)--:chain(godsray)
	post_effect2 = grain:chain(shines)--godsray:chain(shines)--:chain(godsray)
	post_effect3 = godsray2
	
	playerSet = {x = love.window.getWidth()/2, y = love.window.getHeight()/2, inventory = 0, inventoryMax = 20, speed = 150, speedMax = 150, level = 1, health = 10, healthMax = 10, xp = 0, xpNext = 1000, money = 10000, afterBurner = 10, afterBurnerBoost = 0, afterBurnerMax = 10, afterBurnerTimer = 0, afterBurnerTimerSet = 6, guns = 1, gunsOffset = 0,  attack = 1, defence = 1, bulletSpeed = 300, size = 16, name = "", timer = 0, productionTimer = 0}
	
	paused = true
	newGame = true
	newGameSw = true
	gameOver = false
	menu = true
	loading = 0
	found = false
	timer = 0
	
	backgroundColor = {20, 20, 50}
	bgSwitch = true
	bgTimer = 0
	
	shipTimer = 0
	rad = 0
	
	tempLVL = 0
	
	planetsRotTimer = 0
	planetsRotFrame = 0
	planetsRotTimer2 = 0
	planetsRotFrame2 = 0

	timestr = ""
	hour = 0
	min = 0
	sec = 0
	
	universSize = 50000
	X = 0
	Y = 0
	map = false
	zoom = 1
	
	showPrice = false
	openWindow = false
	trade = false
	upgrade = false
	produce = false
	
	extraBg = 0

	waypoint = false
	waypointX = 0
	waypointY = 0
	waypointX2 = 0
	waypointY2 = 0

	up = false
	down = false
	left = false
	right = false
	
	msgs = {}
	bullets = {}
	background = {}
	inventory = {}
	planets = {}
	objects = {}
	factions = {}
	
	resources = {
		{name = "Alien Tech.", value = 50000, rarity = 100, productionName = false},
		{name = "Nano Tech.", value = 25000, rarity = 90, productionName = "Nano Tech. Factory"},
		{name = "Valuables", value = 20000, rarity = 80, productionName = "Bank"},
		{name = "Uranium", value = 17000, rarity = 75, productionName = "Uranium Mine"},
		{name = "Diamond", value = 15000, rarity = 70, productionName = "Diamond Mine"},
		{name = "Gold", value = 10000, rarity = 60, productionName = "Gold Mine"},
		{name = "Medicine", value = 8000, rarity = 55, productionName = "Drug Lab"},
		{name = "Silver", value = 5000, rarity = 50, productionName = "Silver Mine"},
		{name = "Aluminium", value = 3000, rarity = 40, productionName = "Aluminium Mine"},
		{name = "Copper", value = 2000, rarity = 30, productionName = "Copper Mine"},
		{name = "Helium", value = 1500, rarity = 25, productionName = "Helium Distillery"},
		{name = "Hydrogen", value = 1200, rarity = 22, productionName = "Electrolysis Facility"},
		{name = "Iron", value = 1000, rarity = 20, productionName = "Iron Mine"},
		{name = "General Goods", value = 800, rarity = 17, productionName = "Goods Factory"},
		{name = "Lead", value = 600, rarity = 15, productionName = "Lead Mine"},
		{name = "Electronics", value = 500, rarity = 10, productionName = "Electronics Factory"},
		{name = "Nitrogen", value = 400, rarity = 9, productionName = "Nitrogen Generation"},
		{name = "Oxygen", value = 300, rarity = 8, productionName = "Oxygen Distillery"},
		{name = "Alcohol", value = 250, rarity = 7, productionName = "Alcohol Distillery"},
		{name = "Food", value = 150, rarity = 6, productionName = "Farm"},
		{name = "Water", value = 100, rarity = 5, productionName = "Water Extraction"},
		{name = "Scrap", value = 10, rarity = 3, productionName = "Waste Management"}
	}

	pid = 0
	pfound = 0
	
	tbox = {
		x = 5,
		y = 5,
		width = 120,
		height = 18,
		border = 1,
		font = font1,
		text = "",
		textOffsetX = 6,
		textOffsetY = 2,
		borderColor = {0, 255, 0},
		backgroundColor = {20, 20, 20, 0},
		backgroundSelectedColor = {20, 60, 20},
		borderSelectedColor = {140, 245, 0},
		textColor = {100, 255, 0},
		textSelectedColor = {170, 245, 40},
		name = "",
		drawBoxes = true,
		clearTextOnSelect = true,
		centerText = true,
		drawBackground = true,
		selectable = true,
		button1 = {"Buy", func.buttonBuy},
		button2 = {"Sell", func.buttonSell},
		button3 = {"Sell All", func.buttonSellAll}
	}
end

function love.draw()
	doDraw()
end

function love.update(dt)
	
	doUpdate(dt)
	
	TB.update(dt)
	
end

function love.keypressed( key, unicode )
	if key == "f1" then
		if love.window.getFullscreen(true) then
			love.window.setFullscreen(false, "normal")
		 else
			love.window.setFullscreen(true, "normal")
		 end
	end
end

function love.mousepressed( x, y, mb )
	if mb == "wu" and map then
		if zoom < 430 then 
			zoom = math.floor(zoom + (zoom/30))
			if zoom > 430 then
				zoom = 430
			end
		end
	end

	if mb == "wd" and map then
		if zoom > 31 then
			zoom = math.floor(zoom - (zoom/30))
			if zoom < 31 then
				zoom = 31
			end
		end
	end
end